
// lang.js

(function() {
function x(e, t, n) {
if (e === t) return e !== 0 || 1 / e == 1 / t;
if (e == null || t == null) return e === t;
if (e.isEqual && h5.isFunction(e.isEqual)) return e.isEqual(t);
if (t.isEqual && h5.isFunction(t.isEqual)) return t.isEqual(e);
var r = o.call(e);
if (r != o.call(t)) return !1;
switch (r) {
case "[object String]":
return e == String(t);
case "[object Number]":
return e != +e ? t != +t : e == 0 ? 1 / e == 1 / t : e == +t;
case "[object Date]":
case "[object Boolean]":
return +e == +t;
case "[object RegExp]":
return e.source == t.source && e.global == t.global && e.multiline == t.multiline && e.ignoreCase == t.ignoreCase;
}
if (typeof e != "object" || typeof t != "object") return !1;
var i = n.length;
while (i--) if (n[i] == e) return !0;
n.push(e);
var s = 0, u = !0;
if (r == "[object Array]") {
s = e.length, u = s == t.length;
if (u) while (s--) if (!(u = s in e == s in t && x(e[s], t[s], n))) break;
} else {
if ("constructor" in e != "constructor" in t || e.constructor != t.constructor) return !1;
for (var a in e) if (h5.has(e, a)) {
s++;
if (!(u = h5.has(t, a) && x(e[a], t[a], n))) break;
}
if (u) {
for (a in t) if (h5.has(t, a) && !(s--)) break;
u = !s;
}
}
return n.pop(), u;
}
h5 = function(e) {
return new k(e);
};
var e = {}, t = Array.prototype, n = Object.prototype, r = Function.prototype, i = t.slice, s = t.unshift, o = n.toString, u = n.hasOwnProperty, a = t.forEach, f = t.map, l = t.reduce, c = t.reduceRight, h = t.filter, p = t.every, d = t.some, v = t.indexOf, m = t.lastIndexOf, g = Array.isArray, y = Object.keys, b = r.bind, w = h5.each = function(t, n, r) {
if (t === null) return;
if (a && t.forEach === a) t.forEach(n, r); else if (t.length === +t.length) {
for (var i = 0, s = t.length; i < s; i++) if (i in t && n.call(r, t[i], i, t) === e) return;
} else for (var o in t) if (h5.has(t, o) && n.call(r, t[o], o, t) === e) return;
};
h5.map = function(e, t, n) {
var r = [];
return e === null ? r : f && e.map === f ? e.map(t, n) : (w(e, function(e, i, s) {
r[r.length] = t.call(n, e, i, s);
}), e.length === +e.length && (r.length = e.length), r);
}, h5.reduce = function(e, t, n, r) {
var i = arguments.length > 2;
e === null && (e = []);
if (l && e.reduce === l) return r && (t = h5.bind(t, r)), i ? e.reduce(t, n) : e.reduce(t);
w(e, function(e, s, o) {
i ? n = t.call(r, n, e, s, o) : (n = e, i = !0);
});
if (!i) throw new TypeError("Reduce of empty array with no initial value");
return n;
}, h5.reduceRight = function(e, t, n, r) {
var i = arguments.length > 2;
e === null && (e = []);
if (c && e.reduceRight === c) return r && (t = h5.bind(t, r)), i ? e.reduceRight(t, n) : e.reduceRight(t);
var s = h5.toArray(e).reverse();
return r && !i && (t = h5.bind(t, r)), i ? h5.reduce(s, t, n, r) : h5.reduce(s, t);
}, h5.find = function(e, t, n) {
var r;
return E(e, function(e, i, s) {
if (t.call(n, e, i, s)) return r = e, !0;
}), r;
}, h5.filter = function(e, t, n) {
var r = [];
return e === null ? r : h && e.filter === h ? e.filter(t, n) : (w(e, function(e, i, s) {
t.call(n, e, i, s) && (r[r.length] = e);
}), r);
}, h5.reject = function(e, t, n) {
var r = [];
return e === null ? r : (w(e, function(e, i, s) {
t.call(n, e, i, s) || (r[r.length] = e);
}), r);
}, h5.every = function(t, n, r) {
var i = !0;
return t === null ? i : p && t.every === p ? t.every(n, r) : (w(t, function(t, s, o) {
if (!(i = i && n.call(r, t, s, o))) return e;
}), !!i);
};
var E = h5.some = function(t, n, r) {
n || (n = h5.identity);
var i = !1;
return t === null ? i : d && t.some === d ? t.some(n, r) : (w(t, function(t, s, o) {
if (i || (i = n.call(r, t, s, o))) return e;
}), !!i);
};
h5.contains = function(e, t) {
var n = !1;
return e === null ? n : v && e.indexOf === v ? e.indexOf(t) !== -1 : (n = E(e, function(e) {
return e === t;
}), n);
}, h5.invoke = function(e, t) {
var n = i.call(arguments, 2);
return h5.map(e, function(e) {
return (h5.isFunction(t) ? t || e : e[t]).apply(e, n);
});
}, h5.pluck = function(e, t) {
return h5.map(e, function(e) {
return e[t];
});
}, h5.max = function(e, t, n) {
if (!t && h5.isArray(e) && e[0] === +e[0]) return Math.max.apply(Math, e);
if (!t && h5.isEmpty(e)) return -Infinity;
var r = {
computed: -Infinity
};
return w(e, function(e, i, s) {
var o = t ? t.call(n, e, i, s) : e;
o >= r.computed && (r = {
value: e,
computed: o
});
}), r.value;
}, h5.min = function(e, t, n) {
if (!t && h5.isArray(e) && e[0] === +e[0]) return Math.min.apply(Math, e);
if (!t && h5.isEmpty(e)) return Infinity;
var r = {
computed: Infinity
};
return w(e, function(e, i, s) {
var o = t ? t.call(n, e, i, s) : e;
o < r.computed && (r = {
value: e,
computed: o
});
}), r.value;
}, h5.shuffle = function(e) {
var t = [], n;
return w(e, function(e, r, i) {
n = Math.floor(Math.random() * (r + 1)), t[r] = t[n], t[n] = e;
}), t;
}, h5.sortBy = function(e, t, n) {
var r = h5.isFunction(t) ? t : function(e) {
return e[t];
};
return h5.pluck(h5.map(e, function(e, t, i) {
return {
value: e,
criteria: r.call(n, e, t, i)
};
}).sort(function(e, t) {
var n = e.criteria, r = t.criteria;
return n === void 0 ? 1 : r === void 0 ? -1 : n < r ? -1 : n > r ? 1 : 0;
}), "value");
}, h5.groupBy = function(e, t) {
var n = {}, r = h5.isFunction(t) ? t : function(e) {
return e[t];
};
return w(e, function(e, t) {
var i = r(e, t);
(n[i] || (n[i] = [])).push(e);
}), n;
}, h5.sortedIndex = function(e, t, n) {
n || (n = h5.identity);
var r = 0, i = e.length;
while (r < i) {
var s = r + i >> 1;
n(e[s]) < n(t) ? r = s + 1 : i = s;
}
return r;
}, h5.toArray = function(e) {
return e ? h5.isArray(e) ? i.call(e) : h5.isArguments(e) ? i.call(e) : e.toArray && h5.isFunction(e.toArray) ? e.toArray() : h5.values(e) : [];
}, h5.size = function(e) {
return h5.isArray(e) ? e.length : h5.keys(e).length;
}, h5.first = function(e, t, n) {
return h5.isNumber(t) && !n ? i.call(e, 0, t) : e[0];
}, h5.initial = function(e, t, n) {
return i.call(e, 0, e.length - (!h5.isNumber(t) || n ? 1 : t));
}, h5.last = function(e, t, n) {
return h5.isNumber(t) && !n ? i.call(e, Math.max(e.length - t, 0)) : e[e.length - 1];
}, h5.rest = function(e, t, n) {
return i.call(e, !h5.isNumber(t) || n ? 1 : t);
}, h5.compact = function(e) {
return h5.filter(e, function(e) {
return !!e;
});
}, h5.flatten = function(e, t) {
return h5.reduce(e, function(e, n) {
return h5.isArray(n) ? e.concat(t ? n : h5.flatten(n)) : (e[e.length] = n, e);
}, []);
}, h5.without = function(e) {
return h5.difference(e, i.call(arguments, 1));
}, h5.unique = function(e, t, n) {
var r = n ? h5.map(e, n) : e, i = [];
return e.length < 3 && (t = !0), h5.reduce(r, function(n, r, s) {
if (t ? h5.last(n) !== r || !n.length : !h5.contains(n, r)) n.push(r), i.push(e[s]);
return n;
}, []), i;
}, h5.union = function() {
return h5.unique(h5.flatten(arguments, !0));
}, h5.intersection = function(e) {
var t = i.call(arguments, 1);
return h5.filter(h5.unique(e), function(e) {
return h5.every(t, function(t) {
return h5.indexOf(t, e) >= 0;
});
});
}, h5.difference = function(e) {
var t = h5.flatten(i.call(arguments, 1), !0);
return h5.filter(e, function(e) {
return !h5.contains(t, e);
});
}, h5.zip = function() {
var e = i.call(arguments), t = h5.max(h5.pluck(e, "length")), n = new Array(t);
for (var r = 0; r < t; r++) n[r] = h5.pluck(e, "" + r);
return n;
}, h5.indexOf = function(e, t, n) {
if (e === null) return -1;
var r, i;
if (n) return r = h5.sortedIndex(e, t), e[r] === t ? r : -1;
if (v && e.indexOf === v) return e.indexOf(t);
for (r = 0, i = e.length; r < i; r++) if (r in e && e[r] === t) return r;
return -1;
}, h5.lastIndexOf = function(e, t) {
if (e === null) return -1;
if (m && e.lastIndexOf === m) return e.lastIndexOf(t);
var n = e.length;
while (n--) if (n in e && e[n] === t) return n;
return -1;
}, h5.range = function(e, t, n) {
arguments.length <= 1 && (t = e || 0, e = 0), n = arguments[2] || 1;
var r = Math.max(Math.ceil((t - e) / n), 0), i = 0, s = new Array(r);
while (i < r) s[i++] = e, e += n;
return s;
};
var S = function() {};
h5.bind = function(t, n) {
if (t.bind === b && b) return b.apply(t, i.call(arguments, 1));
if (!h5.isFunction(t)) throw new TypeError;
var r = i.call(arguments, 2), s = function() {
if (this instanceof s) {
S.prototype = t.prototype;
var e = new S, o = t.apply(e, r.concat(i.call(arguments)));
return Object(o) === o ? o : e;
}
return t.apply(n, r.concat(i.call(arguments)));
};
return s;
}, h5.bindAll = function(e) {
var t = i.call(arguments, 1);
return t.length === 0 && (t = h5.functions(e)), w(t, function(t) {
e[t] = h5.bind(e[t], e);
}), e;
}, h5.memoize = function(e, t) {
var n = {};
return t || (t = h5.identity), function() {
var r = t.apply(this, arguments);
return h5.has(n, r) ? n[r] : n[r] = e.apply(this, arguments);
};
}, h5.delay = function(e, t) {
var n = i.call(arguments, 2);
return setTimeout(function() {
return e.apply(null, n);
}, t);
}, h5.defer = function(e) {
return h5.delay.apply(h5, [ e, 1 ].concat(i.call(arguments, 1)));
}, h5.throttle = function(e, t) {
var n, r, i, s, o, u, a = h5.debounce(function() {
o = s = !1;
}, t);
return function() {
n = this, r = arguments;
var f = function() {
i = null, o && e.apply(n, r), a();
};
return i || (i = setTimeout(f, t)), s ? o = !0 : u = e.apply(n, r), a(), s = !0, u;
};
}, h5.debounce = function(e, t, n) {
var r;
return function() {
var i = this, s = arguments, o = function() {
r = null, n || e.apply(i, s);
};
n && !r && e.apply(i, s), clearTimeout(r), r = setTimeout(o, t);
};
}, h5.once = function(e) {
var t = !1, n;
return function() {
return t ? n : (t = !0, n = e.apply(this, arguments), n);
};
}, h5.wrap = function(e, t) {
return function() {
var n = [ e ].concat(i.call(arguments, 0));
return t.apply(this, n);
};
}, h5.compose = function() {
var e = arguments;
return function() {
var t = arguments;
for (var n = e.length - 1; n >= 0; n--) t = [ e[n].apply(this, t) ];
return t[0];
};
}, h5.after = function(e, t) {
return e <= 0 ? t() : function() {
if (--e < 1) return t.apply(this, arguments);
};
}, h5.keys = y || function(e) {
if (e !== Object(e)) throw new TypeError("Invalid object");
var t = [];
for (var n in e) h5.has(e, n) && (t[t.length] = n);
return t;
}, h5.values = function(e) {
return h5.map(e, h5.identity);
}, h5.functions = h5.methods = function(e) {
var t = [];
for (var n in e) h5.isFunction(e[n]) && t.push(n);
return t.sort();
}, h5.extend = function(e) {
return w(i.call(arguments, 1), function(t) {
for (var n in t) e[n] = t[n];
}), e;
}, h5.pick = function(e) {
var t = {};
return w(h5.flatten(i.call(arguments, 1)), function(n) {
n in e && (t[n] = e[n]);
}), t;
}, h5.defaults = function(e) {
return w(i.call(arguments, 1), function(t) {
for (var n in t) h5.isUndefined(e[n]) && (e[n] = t[n]);
}), e;
}, h5.clone = function(e) {
return h5.isObject(e) ? h5.isArray(e) ? e.slice() : h5.extend({}, e) : e;
}, h5.tap = function(e, t) {
return t(e), e;
}, h5.isEqual = function(e, t) {
return x(e, t, []);
}, h5.isEmpty = function(e) {
if (e === null) return !0;
if (h5.isArray(e) || h5.isString(e)) return e.length === 0;
for (var t in e) if (h5.has(e, t)) return !1;
return !0;
}, h5.isElement = function(e) {
return !!e && e.nodeType === 1;
}, h5.isArray = g || function(e) {
return o.call(e) === "[object Array]";
}, h5.isObject = function(e) {
return e === Object(e);
}, h5.isArguments = function(e) {
return o.call(e) === "[object Arguments]";
}, h5.isArguments(arguments) || (h5.isArguments = function(e) {
return !!e && !!h5.has(e, "callee");
}), h5.isFunction = function(e) {
return o.call(e) === "[object Function]";
}, h5.isString = function(e) {
return o.call(e) === "[object String]";
}, h5.isNumber = function(e) {
return o.call(e) === "[object Number]";
}, h5.isFinite = function(e) {
return h5.isNumber(e) && isFinite(e);
}, h5.isNaN = function(e) {
return e !== e;
}, h5.isBoolean = function(e) {
return e === !0 || e === !1 || o.call(e) === "[object Boolean]";
}, h5.isDate = function(e) {
return o.call(e) === "[object Date]";
}, h5.isRegExp = function(e) {
return o.call(e) === "[object RegExp]";
}, h5.isNull = function(e) {
return e === null;
}, h5.isUndefined = function(e) {
return e === void 0;
}, h5.has = function(e, t) {
return u.call(e, t);
}, h5.identity = function(e) {
return e;
}, h5.escape = function(e) {
return ("" + e).replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/"/g, "&quot;").replace(/'/g, "&#x27;").replace(/\//g, "&#x2F;");
}, h5.global = this;
var T = function(e, t, n) {
var r = n || h5.global;
for (var i = 0, s; r && (s = e[i]); i++) r = s in r ? r[s] : t ? r[s] = {} : undefined;
return r;
};
h5.setObject = function(e, t, n) {
var r = e.split("."), i = r.pop(), s = T(r, !0, n);
return s && i ? s[i] = t : undefined;
}, h5.getObject = function(e, t, n) {
return T(e.split("."), t, n);
}, h5.irand = function(e) {
return Math.floor(Math.random() * e);
}, h5.cap = function(e) {
return e.slice(0, 1).toUpperCase() + e.slice(1);
}, h5.uncap = function(e) {
return e.slice(0, 1).toLowerCase() + e.slice(1);
};
var N = /\{\$([^\{\}]*)\}/g;
h5.macroize = function(e, t, n) {
var r, i, s = e, o = n || N, u = function(e, n) {
return i = !0, r = h5.getObject(n, !1, t), r === undefined || r === null ? "{$" + n + "}" : r;
}, a = 0;
do i = !1, s = s.replace(o, u); while (i && a++ < 100);
return s;
}, h5.chain = function(e) {
return (new k(e)).chain();
}, h5.mixin = function(e) {
w(h5.functions(e), function(t) {
A(t, h5[t] = e[t]);
});
};
var C = 0;
h5.uniqueId = function(e) {
var t = C++;
return e ? e + t : t;
};
var k = function(e) {
this._wrapped = e;
}, L = function(e, t) {
return t ? (new k(e)).chain() : e;
}, A = function(e, t) {
k.prototype[e] = function() {
var e = i.call(arguments);
return s.call(e, this._wrapped), L(t.apply(h5, e), this._chain);
};
};
w(h5.functions(h5), function(e) {
A(e, h5[e]);
}), w([ "pop", "push", "reverse", "shift", "sort", "splice", "unshift" ], function(e) {
var n = t[e];
k.prototype[e] = function() {
var t = this._wrapped;
n.apply(t, arguments);
var r = t.length;
return (e == "shift" || e == "splice") && r === 0 && delete t[0], L(t, this._chain);
};
}), w([ "concat", "join", "slice" ], function(e) {
var n = t[e];
k.prototype[e] = function() {
return L(n.apply(this._wrapped, arguments), this._chain);
};
}), k.prototype.chain = function() {
return this._chain = !0, this;
}, k.prototype.value = function() {
return this._wrapped;
};
}).call(this);

// Class.js

(function() {
var e = !1;
this.Class = function() {}, Class.extend = function(t) {
var n = this.prototype;
e = !0;
var r = new this;
e = !1, typeof t._subclass == "function" && (r._subclasses = n._subclasses.concat(t._subclass));
if (r._subclasses.length > 0) for (var i = 0; i < r._subclasses.length; i++) r._subclasses[i](n, r, t);
for (var s in t) {
if (s === "_super" || s === "_subclass") continue;
typeof t[s] == "function" && typeof n[s] == "function" && (t[s]._super = n[s]), r[s] = t[s];
}
var o = function() {
e || (typeof this.init == "function" && this.init.apply(this, arguments), typeof this._inited == "function" && this._inited.apply(this, arguments));
};
return o.prototype = r, o.prototype.constructor = o, o.extend = arguments.callee, o;
}, Class.prototype._super = function(e, t) {
return e.callee._super.apply(this, t || e);
}, Class.prototype._subclasses = [];
}).call(this);

// log.js

(function() {
h5.logging = {
level: 99,
levels: {
log: 20,
warn: 10,
error: 0
},
shouldLog: function(e) {
var t = parseInt(h5.logging.levels[e], 10);
return t <= h5.logging.level;
},
_log: function(e, t) {
var n = console[e];
n && n.apply ? n.apply(console, t) : console.log(t);
},
log: function(e, t) {
h5.logging.shouldLog(e) && this._log(e, t);
}
}, h5.setLogLevel = function(e) {
var t = parseInt(e, 10);
isFinite(t) && (h5.logging.level = t);
}, h5.log = function() {
h5.logging.log("log", arguments);
}, h5.warn = function() {
h5.logging.log("warn", arguments);
}, h5.error = function() {
h5.logging.log("error", arguments);
};
}).call(this);

// Object.js

h5.Object = Class.extend({
typeName: "h5.Object",
getProperty: function(e) {
return this[e];
},
setProperty: function(e, t) {
var n = "set" + h5.cap(e);
this[n] ? this[n](t) : this._setProperty(e, t, e + "Changed");
},
log: function() {
var e = arguments, t = e.length, n = [ this.typeName + ": " + (t > 0 ? e[0] : "") ].concat(h5.toArray(e).slice(1));
h5.logging.log("log", n);
},
warn: function() {
this._log("warn", arguments);
},
error: function() {
this._log("error", arguments);
},
_setProperty: function(e, t, n) {
if (this[n]) {
var r = this[e];
this[e] = t, r !== t && this[n](r);
} else this[e] = t;
},
_log: function(e, t) {
var n = [ this.typeName + ": " + (t.length > 0 ? t[0] : "") ].concat(h5.toArray(t).slice(1));
h5.logging.log(e, n);
},
_subclass: function(e, t, n) {
var r = n.published;
if (r) for (var i in r) h5.Object._addGetterSetter(t, n, i, r[i]);
n.typeName || (n.typeName = "h5.UnnamedType");
}
}), h5.Object._addGetterSetter = function(e, t, n, r) {
var i = n;
t[i] === undefined && (e[i] = r);
var s = h5.cap(i), o = "get" + s;
t[o] || (e[o] = function() {
return this.getProperty(i);
});
var u = "set" + s, a = i + "Changed";
t[u] || (e[u] = function(e) {
this._setProperty(i, e, a);
});
};
